<?php
// REGISTER BLOCK
include_once(GG_DIR .'/settings/field_options.php');


// structure
$defaults = array(
	'gid' => array(
		'label'		=> __('Which gallery?', GG_ML),
		'type'		=> 'select',
		'opts'		=> $GLOBALS['gg_guten_galls'],
		'default' 	=> current(array_keys($GLOBALS['gg_guten_galls'])),
		'panel'		=> 'main',
	),
	'width' => array(
		'label'		=> __('Images width', GG_ML),
		'type'		=> 'slider',
		'min'		=> 20,
		'max'		=> 1000,
		'default' 	=> 100,
		'panel'		=> 'main',
	),
	'w_type' => array(
		'label'		=> __('Width unit type', GG_ML),
		'type'		=> 'select',
		'opts'		=> array(
			'px'	=> 'px (static)',
			'%'		=> '% (responsive)',
		),
		'default' 	=> '%',
		'panel'		=> 'main',
	),
	'img_h' => array(
		'label'		=> __('Images height', GG_ML),
		'type'		=> 'slider',
		'min'		=> 20,
		'max'		=> 1000,
		'default' 	=> 75,
		'panel'		=> 'main',
	),
	'h_type' => array(
		'label'		=> __('Height unit type', GG_ML),
		'type'		=> 'select',
		'opts'		=> array(
			'px'	=> 'px (static)',
			'%'		=> '% (responsive)',
		),
		'default' 	=> '%',
		'panel'		=> 'main',
	),
	'layout' => array(
		'label'		=> __('Layout', GG_ML),
		'type'		=> 'select',
		'opts'		=> array('' => __('(as default)', GG_ML)) + gg_itg_layouts(),
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'img_num' => array(
		'label'		=> __('How many images to display?', GG_ML),
		'type'		=> 'select',
		'opts'		=> array(
			'1'	=> 1,
			'2'	=> 2,
			'4'	=> 4,
		),
		'default' 	=> '1',
		'panel'		=> 'main',
	),
	'font_size' => array(
		'label'		=> __("Custom font size", GG_ML) .' (rem)',
		'help'		=> __('Leave empty to use default one', GG_ML),
		'type'		=> 'text',
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'random' => array(
		'label'		=> __('Random display?', GG_ML),
		'type'		=> 'checkbox',
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'watermark' => array(
		'label'		=> __('Use watermark?', GG_ML),
		'type'		=> 'checkbox',
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'ol_txt' => array(
		'label'		=> __("Custom overlay text", GG_ML),
		'help'		=> __('Remember you can use placeholders and FontAwesome icons as explained in settings', GG_ML),
		'type'		=> 'textarea',
		'default' 	=> '',
		'panel'		=> 'main',
	),
);



register_block_type('lcweb/g-itg', array(
	'editor_script' 	=> 'gg_itg_on_guten',
	'render_callback' 	=> 'gg_itg_guten_handler',
	'attributes' 		=> $defaults
));



wp_localize_script('wp-blocks', 'gg_itg_defaults', $defaults);
