<?php 

// get WP pages list - id => title
function gg_get_pages() {
	$pages = array();
	
	foreach(get_pages() as $pag) {
		$pages[ $pag->ID ] = $pag->post_title;	
	}
	
	return $pages;	
}


// galleries pagination systems
function gg_pag_sys() {
	return array(
		'standard' 			=> __('Standard', GG_ML),
		'inf_scroll'		=> __('Infinite scroll', GG_ML),
		'auto_inf_scroll'	=> __('Automatic Infinite scroll', GG_ML),
		'num_btns'	 		=> __('Numbered buttons', GG_ML),
		'dots'	 			=> __('Dots', GG_ML),
	);
}


// galleries pagination systems
function gg_deeplink_elems() {
	return array(
		'ggt_' => __('Gallery tags', GG_ML),
		'ggs_' => __('Gallery search', GG_ML),
		'ggp_' => __('Gallery page', GG_ML),
		'gcc_' => __('Collection category', GG_ML),
		'gcg_' => __('Collection gallery', GG_ML),
	);
}


// pagination layouts
function gg_pag_layouts($type = false) {
	$types = array(
		'standard' 	 	=> __('Commands + full text', GG_ML),
		'only_num'  	=> __('Commands + page numbers', GG_ML),
		'only_arr'		=> __('Only arrows', GG_ML),
		'only_arr_mb'	=> __('Only arrows - monoblock', GG_ML),	
	);
	
	if($type === false) {return $types;}
	else {return $types[$type];}
}


// image-to-gallery layouts
function gg_itg_layouts($layout = false) {
	$layouts = array(
		'corner_txt' 	=> __('Bottom-right corner overlay on last image', GG_ML),
		'100_op_ol'  	=> __('100% opaque - full overlay on last image', GG_ML),
		'50_op_ol'		=> __('50% opaque - full overlay on last image', GG_ML),
		'0_op_ol'		=> __('0% opaque - full overlay on last image', GG_ML),
		'block_over'	=> __('Centered text block over images', GG_ML),	
		'main_n_sides'	=> __('Main image with central overlay + two smaller on sides', GG_ML),	
	);
	
	if($layout === false) {return $layouts;}
	else {return $layouts[$layout];}	
}


// slider cropping methods
function gg_galleria_crop_methods($type = false) {
	$types = array(
		'true' 		=> __('Fit, center and crop', GG_ML),
		'false' 	=> __('Scale down', GG_ML),
		'height'	=> __('Scale to fill the height', GG_ML),
		'width'		=> __('Scale to fill the width', GG_ML),
		'landscape'	=> __('Fit images with landscape proportions', GG_ML),
		'portrait' 	=> __('Fit images with portrait proportions', GG_ML)
	);
	
	if($type === false) {return $types;}
	else {return $types[$type];}
}


// slider effects
function gg_galleria_fx($type = false) {
	$types = array(
		'fadeslide' => __('Fade and slide', GG_ML),
		'fade' 		=> __('Fade', GG_ML),
		'flash'		=> __('Flash', GG_ML),
		'pulse'		=> __('Pulse', GG_ML),
		'slide'		=> __('Slide', GG_ML),
		''			=> __('None', GG_ML)
	);
	
	if($type === false) {return $types;}
	else {return $types[$type];}
}


// slider thumbs visibility options
function gg_galleria_thumb_opts($type = false) {
	$types = array(
		'always'	=> __('Always', GG_ML),
		'yes' 		=> __('Yes with toggle button', GG_ML),
		'no' 		=> __('No with toggle button', GG_ML),
		'never' 	=> __('Never', GG_ML),
	);
	
	if($type === false) {return $types;}
	else {return $types[$type];}
}


// preloader types
function gg_preloader_types($type = false) {
	$types = array(
		'default' 				=> __('Default loader', GG_ML),
		'rotating_square' 		=> __('Rotating square', GG_ML),
		'overlapping_circles' 	=> __('Overlapping circles', GG_ML),
		'stretch_rect' 			=> __('Stretching rectangles', GG_ML),
		'spin_n_fill_square'	=> __('Spinning & filling square', GG_ML),
		'pulsing_circle' 		=> __('Pulsing circle', GG_ML),
		'spinning_dots'			=> __('Spinning dots', GG_ML),
		'appearing_cubes'		=> __('Appearing cubes', GG_ML),
		'folding_cube'			=> __('Folding cube', GG_ML),
		'old_style_spinner'		=> __('Old-style spinner', GG_ML),
		'minimal_spinner'		=> __('Minimal spinner', GG_ML),
		'spotify_like'			=> __('Spotify-like spinner', GG_ML),
		'vortex'				=> __('Vortex', GG_ML),
		'bubbling_dots'			=> __('Bubbling Dots', GG_ML),
		'overlapping_dots'		=> __('Overlapping dots', GG_ML),
		'fading_circles'		=> __('Fading circles', GG_ML),
	);
	return (!$type) ? $types : $types[$type];
}


// lightboxes list
function gg_lightboxes($type = false) {
	$types = array(
		'lcweb' 	=> 'LC Lightbox',
		'lightcase' => 'Lightcase',
		'simplelb' 	=> 'Simple Lightbox',
		'tosrus' 	=> 'Tos "R"Us',
		'mag_popup' => 'Magnific Popup',
		'imagelb' 	=> 'imageLightbox',
		'photobox' 	=> 'Photobox',
		'fancybox'	=> 'Fancybox (not responsive)',
		'colorbox' 	=> 'Colorbox',
		'prettyphoto' 	=> 'PrettyPhoto (not responsive)',
	);
	return (!$type) ? $types : $types[$type];
}



// lightcase lightbox - transition styles
function gg_lightcase_trans_styles() {
	return array(
		'none'				=> __('No transition', GG_ML), 
		'fade'				=> __('Fade', GG_ML),  
		'elastic'			=> __('Elastic', GG_ML),
		'scrollTop'			=> __('Downwards', GG_ML),
		'scrollRight'		=> __('Leftwards', GG_ML), 
		'scrollBottom'		=> __('Upwards', GG_ML),
		'scrollLeft'		=> __('Rightwards', GG_ML),
		'scrollHorizontal'	=> __('Horizontal scroll', GG_ML),
		'scrollVertical'	=> __('Vertical scroll', GG_ML),
	);
}


// LC Lightbox - openClose effects list
function gg_lcl_openclose_list() {
	return array(
		'lcl_fade_oc' 		=> __('Fade', GG_ML),
		'lcl_zoomin_oc' 	=> __('Zoom-in', GG_ML),
		'lcl_bottop_oc' 	=> __('Bottom to top', GG_ML),
		'lcl_bottop_v2_oc' 	=> __('Bottom to top v2', GG_ML),
		'lcl_rtl_oc' 		=> __('Right to left', GG_ML),
		'lcl_horiz_flip_oc' => __('Horizontal flip', GG_ML),
		'lcl_vert_flip_oc' 	=> __('Vertical flip', GG_ML),
		'' 					=> __('None (customizable through CSS)', GG_ML),
	);
}


// get the LC lightbox patterns list 
function gg_lcl_patterns_list() {
	$patterns = array();
	$patterns_list = scandir(GG_DIR."/js/lightboxes/lc-lightbox/img/patterns");
	
	foreach($patterns_list as $pattern_name) {
		if($pattern_name != '.' && $pattern_name != '..') {
			$patterns[$pattern_name] = substr($pattern_name, 0, -4);
		}
	}
	return $patterns;	
}

